diff --git a/plugins/imfile/imfile.c b/plugins/imfile/imfile.c
index 950b62918..a5d20823f 100644
--- a/plugins/imfile/imfile.c
+++ b/plugins/imfile/imfile.c
@@ -2600,11 +1973,7 @@ do_inotify(void)
 	int currev;
 	DEFiRet;
 
-dbgprintf("pre wdmapinit\n");
 	CHKiRet(wdmapInit());
-dbgprintf("pre dirsinit\n");
-	CHKiRet(dirsInit());
-dbgprintf("pre inotify_init\n");
 	ino_fd = inotify_init();
 	if(ino_fd < 0) {
 		LogError(errno, RS_RET_INOTIFY_INIT_FAILED, "imfile: Init inotify "
@@ -2612,9 +1981,9 @@ dbgprintf("pre inotify_init\n");
 		return RS_RET_INOTIFY_INIT_FAILED;
 	}
 	DBGPRINTF("inotify fd %d\n", ino_fd);
-dbgprintf("pre setuInitialWatches\n");
-	in_setupInitialWatches();
-dbgprintf("post setuInitialWatches\n");
+
+	/* do watch initialization */
+	fs_node_walk(runModConf->conf_tree, poll_tree);
 
 	while(glbl.GetGlobalInputTermState() == 0) {
 		if(runModConf->haveReadTimeouts) {
@@ -2626,7 +1995,8 @@ dbgprintf("post setuInitialWatches\n");
 				r = poll(&pollfd, 1, runModConf->timeoutGranularity);
 			} while(r  == -1 && errno == EINTR);
 			if(r == 0) {
-				in_do_timeout_processing();
+				DBGPRINTF("readTimeouts are configured, checking if some apply\n");
+				fs_node_walk(runModConf->conf_tree, poll_timeouts);
 				continue;
 			} else if (r == -1) {
 				LogError(errno, RS_RET_INTERNAL_ERROR,
@@ -2709,499 +2079,71 @@ fen_printevent(int event)
 	}
 }
 
-static rsRetVal ATTR_NONNULL(1)
-fen_removeFile(lstn_t *pLstn)
-{
-	struct stat statFile;
-	uchar statefile[MAXFNAME];
-	uchar toDel[MAXFNAME];
-	int bDoRMState;
-	uchar *statefn;
-	int dirIdx;
-	int ftIdx;
-	DEFiRet;
-
-	/* Get correct dirindex from basedir! */
-	dirIdx = dirsFindDir(pLstn->pszDirName);
-	if (dirIdx == -1) {
-		/* Add error processing as required, file may have been deleted/moved. */
-		LogError(errno, RS_RET_SYS_ERR, "fen_removeFile: Failed to remove file, "
-			"unknown directory index for dir '%s'\n", pLstn->pszDirName);
-		ABORT_FINALIZE(RS_RET_SYS_ERR);
-	}
-
-	if(pLstn->bRMStateOnDel) {
-		statefn = getStateFileName(pLstn, statefile, sizeof(statefile), NULL);
-		/* Get full path and file name */
-		getFullStateFileName(statefn, toDel, sizeof(toDel));
-		bDoRMState = 1;
-	} else {
-		bDoRMState = 0;
-	}
-
-	/* one final try to gather data */
-	pollFile(pLstn, NULL);
-
-	/* Check for active / configure file */
-	if ( (ftIdx = fileTableSearchNoWildcard(&dirs[dirIdx].active, pLstn->pszBaseName)) >= 0) {
-		DBGPRINTF("fen_removeFile removing active listener for '%s', dirIdx %d, ftIdx %d\n",
-			pLstn->pszFileName, dirIdx, ftIdx);
-		fileTableDelFile(&dirs[dirIdx].active, pLstn);	/* Remove from filetable */
-		lstnDel(pLstn);					/* Delete Listener now */
-	} else {
-		DBGPRINTF("fen_removeFile NOT removing configured listener for '%s', dirIdx %d\n",
-			pLstn->pszFileName, dirIdx, ftIdx);
-	}
-
-	if(bDoRMState) {
-		DBGPRINTF("fen_removeFile unlinking '%s'\n", toDel);
-		if((stat((const char*) toDel, &statFile) == 0) && unlink((char*)toDel) != 0) {
-			LogError(errno, RS_RET_ERR, "fen_removeFile: could not remove state "
-				"file \"%s\": %s", toDel);
-		}
-	}
-finalize_it:
-	RETiRet;
-}
-
-static rsRetVal
-fen_removeDir(int dirIdx)
-{
-	DEFiRet;
-
-	DBGPRINTF("fen_removeDir removing dir (idx %d) '%s' \n", dirIdx, dirs[dirIdx].dirName);
-
-	/* Delete dir from dirs array! */
-	free(dirs[dirIdx].dirName);
-	free(dirs[dirIdx].dirNameBfWildCard);
-	free(dirs[dirIdx].active.listeners);
-	free(dirs[dirIdx].configured.listeners);
-	dirs[dirIdx].dirName = NULL;
-	dirs[dirIdx].dirNameBfWildCard = NULL;
-finalize_it:
-	RETiRet;
-}
-
-static rsRetVal
-fen_processEventFile(struct file_obj* fobjp, lstn_t *pLstn, int revents, int dirIdx)
-{
-	struct stat statFile;
-	int ftIdx;
-	DEFiRet;
-
-	// Use FileObj from listener if NULL
-	if (fobjp== NULL)
-		fobjp = &pLstn->pfinf->fobj;
-
-	/* uncomment if needed DBGPRINTF("fen_processEventFile: %s (0x%" PRIXPTR ") ", fobjp->fo_name, pLstn); **/
-	DBGPRINTF("fen_processEventFile: %s ", fobjp->fo_name);
-	if (revents) {
-		fen_printevent(revents);
-	}
-	DBGPRINTF("\n");
-
-	if (pLstn == NULL) {
-		/* Should not be NULL but it case it is abort */
-		DBGPRINTF("fen_processEventFile: Listener '%s' for EVENT already deleted, aborting function.\n",
-			fobjp->fo_name);
-		FINALIZE;
-	}
-
-	/* Port needs to be reassociated */
-	pLstn->bPortAssociated = 0;
-
-	/* Compare filename first */
-	if (strcmp(fobjp->fo_name, (const char*)pLstn->pszFileName) == 0){
-		DBGPRINTF("fen_processEventFile: matching file found: '%s'\n", fobjp->fo_name);
-
-		/* Get File Stats */
-		if (!(revents & FILE_EXCEPTION) && stat(fobjp->fo_name, &statFile) == -1) {
-			const int errno_save = errno;
-			DBGPRINTF("fen_processEventFile: Failed to stat file: %s - errno %d\n",
-				fobjp->fo_name, errno);
-			LogError(errno_save, RS_RET_FILE_NO_STAT, "imfile: file '%s' not found when "
-				"receiving notification event", fobjp->fo_name);
-			ABORT_FINALIZE(RS_RET_FILE_NO_STAT);
-		}
-
-		/*
-		* Add what ever processing that needs to be done
-		* here. Process received events.
-		*/
-		if (revents) {
-			if (revents & FILE_MODIFIED) {
-				/* File has been modified, trigger a pollFile */
-				pollFile(pLstn, NULL);
-			} else if (revents & FILE_RENAME_FROM) {
-				/* File has been renamed which means it was deleted. remove the file*/
-				fen_removeFile(pLstn);
-				FINALIZE;
-			}
-
-			/* check for file exception. Only happens when really bad things happened like
-			harddisk removal. We need to re-register he port. */
-			if (revents & FILE_EXCEPTION) {
-				fen_removeFile(pLstn);
-				ABORT_FINALIZE(RS_RET_SYS_ERR);
-			}
-		}
-	} else {
-		DBGPRINTF("fen_processEventFile: file '%s' did not match Listener Filename '%s'\n",
-			fobjp->fo_name, pLstn->pszFileName);
-		ABORT_FINALIZE(RS_RET_SYS_ERR);
-	}
-
-	/* Register file event */
-	fobjp->fo_atime = statFile.st_atim;
-	fobjp->fo_mtime = statFile.st_mtim;
-	fobjp->fo_ctime = statFile.st_ctim;
-	if (port_associate(glport, PORT_SOURCE_FILE, (uintptr_t)fobjp,
-				pLstn->pfinf->events, (void *)pLstn) == -1) {
-		/* Add error processing as required, file may have been deleted/moved. */
-		LogError(errno, RS_RET_SYS_ERR, "fen_processEventFile: Failed to associated port for file "
-			": %s - errno %d\n", fobjp->fo_name, errno);
-		ABORT_FINALIZE(RS_RET_SYS_ERR);
-	} else {
-		/* Port successfull listening now*/
-		DBGPRINTF("fen_processEventFile: associated port for file %s\n", fobjp->fo_name);
-		pLstn->bPortAssociated = 1;
-	}
-finalize_it:
-	RETiRet;
-}
-
-/* Helper function to find matching files for listener */
-rsRetVal
-fen_DirSearchFiles(lstn_t *pLstn, int dirIdx)
-{
-	struct file_obj *fobjp = NULL;	/* Helper object */
-	rsRetVal localRet;
-	int ftIdx;
-	int result;
-	glob_t files;
-	lstn_t *pLstnNew;
-	/* Helper chars */
-	uchar basedir[MAXFNAME];
-	uchar basefilename[MAXFNAME];
-	uchar *file;
-	DEFiRet;
-
-	DBGPRINTF("fen_DirSearchFiles search for dynamic files with pattern '%s' \n", pLstn->pszFileName);
-	result = glob(	(char*)pLstn->pszFileName,
-			GLOB_MARK|runModConf->sortFiles|GLOB_BRACE,
-			NULL, &files);
-	if(result == 0) {
-		DBGPRINTF("fen_DirSearchFiles found %d matches with pattern '%s' \n", files.gl_pathc,
-			pLstn->pszFileName);
-		for(unsigned i = 0 ; i < files.gl_pathc ; i++) {
-			/* Get File, Dir and Basename */
-			file = (uchar*)files.gl_pathv[i];
-			getBasename(basefilename, file);
-			getBasedir(basedir, file);
-
-			if(file[strlen((char*)file)-1] == '/')
-				continue;/* we cannot process subdirs! */
-
-			DBGPRINTF("fen_DirSearchFiles found matching file '%s' \n", file);
-
-			/* Get correct dirindex from basedir! */
-			dirIdx = dirsFindDir(basedir);
-			if (dirIdx == -1) {
-				/* Add dir to table and create watch */
-				CHKiRet(dirsAdd(basedir, &dirIdx));
-				DBGPRINTF("fen_DirSearchFiles adding new dir '%s' to dirs table idx %d\n",
-					basedir, dirIdx);
-//				fen_processEventDir(NULL, dirIdx, 0); /* Monitor child directory as well */
-			}
-
-			/* Search for file index here */
-			ftIdx = fileTableSearchNoWildcard(&dirs[dirIdx].active, (uchar*)basefilename);
-			if(ftIdx >= 0) {
-				DBGPRINTF("fen_DirSearchFiles file '%s' idx %d already being monitored ... \n",
-					file, ftIdx);
-			} else {
-				DBGPRINTF("fen_DirSearchFiles setup new monitor for dynamic file '%s' \n", file);
-
-				/* duplicate listener firs */
-				pLstnNew = pLstn;
-				localRet = lstnDup(&pLstnNew, basefilename, dirs[dirIdx].dirName);
-				if(localRet != RS_RET_OK) {
-					DBGPRINTF("fen_DirSearchFiles failed to duplicate listener for '%s' "
-						"with iRet %d\n", localRet, pLstn->pszFileName);
-					ABORT_FINALIZE(localRet);
-				}
-
-				// Create FileInfo struct
-				pLstnNew->pfinf = malloc(sizeof(struct fileinfo));
-				if (pLstnNew->pfinf == NULL) {
-					LogError(errno, RS_RET_IO_ERROR, "fen_DirSearchFiles alloc memory "
-						"for fileinfo failed ");
-					ABORT_FINALIZE(RS_RET_IO_ERROR);
-				}
-				if ((pLstnNew->pfinf->fobj.fo_name = strdup((char*)pLstnNew->pszFileName)) == NULL) {
-					LogError(errno, RS_RET_IO_ERROR, "fen_DirSearchFiles alloc memory "
-						"for strdup failed ");
-					free(pLstnNew->pfinf);
-					pLstnNew->pfinf = NULL;
-					ABORT_FINALIZE(RS_RET_IO_ERROR);
-				}
-				/* Event types to watch. */
-				pLstnNew->pfinf->events = FILE_MODIFIED;
-				pLstnNew->pfinf->port = glport;
-
-				/* Add Listener to configured dirs tab */
-				dirsAddFile(pLstnNew, ACTIVE_FILE);
-
-				DBGPRINTF("fen_DirSearchFiles duplicated listener for '%s/%s' \n",
-					pLstnNew->pszDirName, pLstnNew->pszBaseName);
-
-				/* Trigger file processing */
-				fen_processEventFile(NULL, pLstnNew, FILE_MODIFIED, dirIdx);
-			}
-
-		}
-		globfree(&files);
-	} else {
-		DBGPRINTF("fen_DirSearchFiles found ZERO matches with pattern '%s' \n", pLstn->pszFileName);
-	}
-
-finalize_it:
-	RETiRet;
-}
-
-/* function not used yet, will be needed for wildcards later */
-rsRetVal
-fen_processEventDir(struct file_obj* fobjp, int dirIdx, int revents)
-{
-	int iListIdx;
-	struct stat statFile;
-	sbool hasWildcard;
-	DEFiRet;
-
-	DBGPRINTF("fen_processEventDir '%s' (Configured %d)", dirs[dirIdx].dirName,
-		dirs[dirIdx].configured.currMax);
-
-	// Use FileObj from dirinfo if NULL
-	if (fobjp== NULL)
-		fobjp = &dirs[dirIdx].pfinf->fobj;
-
-	/* Port needs to be reassociated */
-	dirs[dirIdx].bPortAssociated = 0;
-
-	if (revents) {
-		fen_printevent(revents);
-		DBGPRINTF("\n");
-		DBGPRINTF("fen_processEventDir DIR EVENTS needs to be processed for '%s'('%s')\n",
-			fobjp->fo_name, dirs[dirIdx].dirName);
-
-		/* a file was modified */
-		if (revents & FILE_MODIFIED) {
-			/* LOOP through configured Listeners */
-			for(iListIdx = 0; iListIdx < dirs[dirIdx].configured.currMax; iListIdx++) {
-				hasWildcard = (	dirs[dirIdx].hasWildcard ||
-						dirs[dirIdx].configured.listeners[iListIdx].pLstn->hasWildcard
-							? TRUE : FALSE);
-				if (hasWildcard == 1){
-					/* Handle Wildcard files */
-					fen_DirSearchFiles(	dirs[dirIdx].configured.listeners[iListIdx].pLstn,
-								dirIdx);
-				} else {
-					/* Handle fixed configured files */
-					if (dirs[dirIdx].configured.listeners[iListIdx].pLstn->bPortAssociated == 0) {
-						DBGPRINTF("fen_processEventDir Listener for %s needs to be checked\n",
-						dirs[dirIdx].configured.listeners[iListIdx].pLstn->pszFileName);
-						/* Need to check if listener file was created! */
-						fen_processEventFile(NULL,
-							dirs[dirIdx].configured.listeners[iListIdx].pLstn,
-							FILE_MODIFIED
-						/*dirs[dirIdx].configured.listeners[iListIdx].pLstn->pfinf->events*/,
-							dirIdx);
-					} else {
-						DBGPRINTF("fen_processEventDir Listener for %s already associated\n",
-						dirs[dirIdx].configured.listeners[iListIdx].pLstn->pszFileName);
-					}
-				}
-			}
-		}
-	} else {
-		DBGPRINTF("\n");
-	}
-
-	/* Check if dir exists */
-	if (stat(fobjp->fo_name, &statFile) == 0 && S_ISDIR(statFile.st_mode)) {
-		DBGPRINTF("fen_processEventDir '%s'('%s') is a valid directory, associate port\n"
-			, fobjp->fo_name, dirs[dirIdx].dirName, errno);
-	} else {
-		DBGPRINTF("fen_processEventDir Failed to stat directory: '%s'('%s') - errno %d, removing\n"
-			, fobjp->fo_name, dirs[dirIdx].dirName, errno);
-		fen_removeDir(dirIdx); /* Remove dir */
-		ABORT_FINALIZE(RS_RET_FILE_NO_STAT);
-	}
-
-	/* Register file event */
-	fobjp->fo_atime = statFile.st_atim;
-	fobjp->fo_mtime = statFile.st_mtim;
-	fobjp->fo_ctime = statFile.st_ctim;
-	if (port_associate(glport, PORT_SOURCE_FILE, (uintptr_t)fobjp, dirs[dirIdx].pfinf->events,
-		(void *)dirIdx) == -1) {
-		/* Add error processing as required, file may have been deleted/moved. */
-		LogError(errno, RS_RET_SYS_ERR, "fen_processEventDir: Failed to associated port "
-			"for directory: '%s'('%s') - errno %d\n", fobjp->fo_name, dirs[dirIdx].dirName, errno);
-		ABORT_FINALIZE(RS_RET_SYS_ERR);
-	} else {
-		/* Port successfull listening now*/
-		DBGPRINTF("fen_processEventDir associated port for dir '%s'('%s')\n"
-			, fobjp->fo_name, dirs[dirIdx].dirName);
-		dirs[dirIdx].bPortAssociated = 1;
-	}
-finalize_it:
-	RETiRet;
-
-}
-
-/* Setup directory watches, based on user config */
-static void
-fen_setupDirWatches(void)
-{
-	int i;
-	for(i = 0 ; i < currMaxDirs ; ++i) {
-		if (	dirs[i].bPortAssociated == 0 &&
-			dirs[i].dirName != NULL		/* Don't check deleted dirs */ ){
-			fen_processEventDir(NULL, i, 0);/* no events on init*/
-		}
-	}
-}
-
-/* Setup static file watches, based on user config */
-static void
-fen_setupFileWatches(void)
-{
-	/* Listener helper*/
-	lstn_t *pLstn;
-	int dirIdx;
-
-	/* Additional check for not associated files */
-	for(pLstn = runModConf->pRootLstn ; pLstn != NULL ; pLstn = pLstn->next) {
-		/* Search for dirIdx in case directory has wildcard */
-		dirIdx = dirsFindDir(pLstn->pszDirName);
-
-		if (	pLstn->bPortAssociated == 0 &&
-			pLstn->hasWildcard == 0 /* WildCard File Watches are Setup in EventDir */ &&
-			(dirIdx >= 0 && dirs[dirIdx].hasWildcard == FALSE)
-			){
-			/* Check if file exists now */
-			fen_processEventFile(NULL, pLstn, pLstn->pfinf->events, dirIdx);
-		}
-	}
-}
 
+/* https://docs.oracle.com/cd/E19253-01/816-5168/port-get-3c/index.html */
 static rsRetVal
 do_fen(void)
 {
-	int bHadFileData; /* were there at least one file with data during this run? */
 	port_event_t portEvent;
 	struct timespec timeout;
-	lstn_t *pLstn;			/* Listener helper*/
-	struct file_obj *fobjp = NULL;	/* Helper object */
-	struct stat statFile;
 	DEFiRet;
-	rsRetVal iRetTmp = RS_RET_OK;
+	//rsRetVal iRetTmp = RS_RET_OK;
 
-	/* Set port timeout to 1 second. We need to checkfor unmonitored files during meantime */
-	timeout.tv_sec = 1;
+	/* Set port timeout to 1 second. We need to check for unmonitored files during meantime */
+	// TODO: do we need this timeout at all for equality to old code?
+	// TODO: do we need it to support the timeout feature!
+	timeout.tv_sec = 300;
 	timeout.tv_nsec = 0;
 
 	/* create port instance */
-	if ((glport = port_create()) == -1) {
+	if((glport = port_create()) == -1) {
 		LogError(errno, RS_RET_FEN_INIT_FAILED, "do_fen INIT Port failed ");
 		return RS_RET_FEN_INIT_FAILED;
 	}
 
-	/* create port instance */
-	CHKiRet(dirsInit());
-
-	/* Loop through all configured listeners */
-	for(pLstn = runModConf->pRootLstn ; pLstn != NULL ; pLstn = pLstn->next) {
-		if(pLstn->masterLstn == NULL) {
-			DBGPRINTF("do_fen process '%s' in '%s'\n", pLstn->pszBaseName, pLstn->pszDirName);
-			// Create FileInfo struct
-			pLstn->pfinf = malloc(sizeof(struct fileinfo));
-			if (pLstn->pfinf == NULL) {
-				LogError(errno, RS_RET_FEN_INIT_FAILED, "do_fen: alloc memory "
-					"for fileinfo failed ");
-				ABORT_FINALIZE(RS_RET_FEN_INIT_FAILED);
-			}
-			if ((pLstn->pfinf->fobj.fo_name = strdup((char*)pLstn->pszFileName)) == NULL) {
-				LogError(errno, RS_RET_FEN_INIT_FAILED, "do_fen: alloc memory "
-					"for strdup failed ");
-				free(pLstn->pfinf);
-				pLstn->pfinf = NULL;
-				ABORT_FINALIZE(RS_RET_FEN_INIT_FAILED);
-			}
-
-			/* Event types to watch. */
-			pLstn->pfinf->events = FILE_MODIFIED;
-			/* Not needed/working |FILE_DELETE|FILE_RENAME_TO|FILE_RENAME_FROM;*/
-			pLstn->pfinf->port = glport;
-		}
-
-		/* Add Listener to configured dirs tab */
-		dirsAddFile(pLstn, CONFIGURED_FILE);
-	}
-
-	/* Init File watches ONCE */
-	fen_setupFileWatches();
+	/* do watch initialization */
+	fs_node_walk(runModConf->conf_tree, poll_tree);
 
 	DBGPRINTF("do_fen ENTER monitoring loop \n");
 	while(glbl.GetGlobalInputTermState() == 0) {
 		DBGPRINTF("do_fen loop begin... \n");
+		/* Loop through events, if there are any */
+		while (!port_get(glport, &portEvent, &timeout)) { // wie inotify-wait
+			DBGPRINTF("do_fen: received port event with ");
+			fen_printevent((int) portEvent.portev_events);
+			DBGPRINTF("\n");
+			if(portEvent.portev_source != PORT_SOURCE_FILE) {
+				LogError(errno, RS_RET_SYS_ERR, "do_fen: Event from unexpected source "
+					": %d\n", portEvent.portev_source);
+				continue;
+			}
+			act_obj_t *const act = (act_obj_t*) portEvent.portev_user;
+			DBGPRINTF("do_fen event received: deleted %d, is_file %d, name '%s' foname '%s'\n",
+				act->is_deleted, act->edge->is_file, act->name,
+				((struct file_obj*)portEvent.portev_object)->fo_name);
+			if(act->is_deleted) {
+				free(act->name);
+				free(act);
+				continue;
+			}
 
-		/* Check for not associated directories and add dir watches */
-		fen_setupDirWatches();
+			/* we need to re-associate the object */
+			act->bPortAssociated = 0;
+			fen_setupWatch(act);
 
-		/* Loop through events, if there are any */
-		while (!port_get(glport, &portEvent, &timeout)) {
-			switch (portEvent.portev_source) {
-				case PORT_SOURCE_FILE:
-					/* check if file obj is DIR or FILE */
-					fobjp = (struct file_obj*) portEvent.portev_object;
-					DBGPRINTF("do_fen event received for '%s', processing ... \n",
-						fobjp->fo_name);
-
-					/* Check if we habe a DIR or FILE */
-					if (stat(fobjp->fo_name, &statFile) == 0 && S_ISDIR(statFile.st_mode)) {
-						fen_processEventDir(fobjp, (int)portEvent.portev_user,
-							portEvent.portev_events);
-					} else {
-						/* Call file events event handler */
-						fen_processEventFile(fobjp, (lstn_t*)portEvent.portev_user,
-							portEvent.portev_events, -1 /* Unknown diridx */);
-					}
-					break;
-				default:
-					LogError(errno, RS_RET_SYS_ERR, "do_fen: Event from unexpected source "
-						": %d\n", portEvent.portev_source);
+			if(act->edge->is_file) {
+				pollFile(act);
+			} else {
+				// curr: fs_node_walk(act->edge->parent, poll_tree);
+				fs_node_walk(act->edge->node, poll_tree);
 			}
 		}
-
-		DBGPRINTF("do_fen loop end... \n");
 	}
-	DBGPRINTF("do_fen EXIT monitoring loop \n");
 
-finalize_it:
-	/*
-	* close port, will de-activate all file events watches associated
-	* with the port.
-	*/
+	/* close port, will de-activate all file events watches associated
+	 * with the port.
+	 */
 	close(glport);
-
-	/* Free memory now */
-	for(pLstn = runModConf->pRootLstn ; pLstn != NULL ; pLstn = pLstn->next) {
-		free(pLstn->pfinf->fobj.fo_name);
-		free(pLstn->pfinf);
-		pLstn->pfinf = NULL;
-	}
-
 	RETiRet;
 }
 #else /* #if OS_SOLARIS */
@@ -3212,7 +2154,6 @@ do_fen(void)
 			"platform does not support fen");
 	return RS_RET_NOT_IMPLEMENTED;
 }
-
 #endif /* #if OS_SOLARIS */
 
 
@@ -3263,17 +2204,18 @@ ENDwillRun
  * iRet as that makes matters worse (at least we can try persisting the others...).
  * rgerhards, 2008-02-13
  */
-static rsRetVal
-persistStrmState(lstn_t *pLstn)
+static rsRetVal ATTR_NONNULL()
+persistStrmState(act_obj_t *const act)
 {
 	DEFiRet;
 	strm_t *psSF = NULL; /* state file (stream) */
 	size_t lenDir;
 	uchar statefile[MAXFNAME];
 
-	uchar *const statefn = getStateFileName(pLstn, statefile, sizeof(statefile), NULL);
-	DBGPRINTF("persisting state for '%s' to file '%s'\n",
-		  pLstn->pszFileName, statefn);
+	const instanceConf_t *const inst = act->edge->instarr[0];// TODO: same file, multiple instances?
+
+	uchar *const statefn = getStateFileName(act, statefile, sizeof(statefile));
+	DBGPRINTF("persisting state for '%s' to file '%s'\n", act->name, statefn);
 	CHKiRet(strm.Construct(&psSF));
 	lenDir = ustrlen(glbl.GetWorkDir());
 	if(lenDir > 0)
@@ -3281,10 +2223,10 @@ persistStrmState(lstn_t *pLstn)
 	CHKiRet(strm.SettOperationsMode(psSF, STREAMMODE_WRITE_TRUNC));
 	CHKiRet(strm.SetsType(psSF, STREAMTYPE_FILE_SINGLE));
 	CHKiRet(strm.SetFName(psSF, statefn, strlen((char*) statefn)));
-	CHKiRet(strm.SetFileNotFoundError(psSF, pLstn->fileNotFoundError));
+	CHKiRet(strm.SetFileNotFoundError(psSF, inst->fileNotFoundError));
 	CHKiRet(strm.ConstructFinalize(psSF));
 
-	CHKiRet(strm.Serialize(pLstn->pStrm, psSF));
+	CHKiRet(strm.Serialize(act->pStrm, psSF));
 	CHKiRet(strm.Flush(psSF));
 
 	CHKiRet(strm.Destruct(&psSF));
@@ -3308,11 +2250,6 @@ finalize_it:
  */
 BEGINafterRun
 CODESTARTafterRun
-	while(runModConf->pRootLstn != NULL) {
-		/* Note: lstnDel() reasociates root! */
-		lstnDel(runModConf->pRootLstn);
-	}
-
 	if(pInputName != NULL)
 		prop.Destruct(&pInputName);
 ENDafterRun
@@ -3337,28 +2274,9 @@ CODESTARTmodExit
 	objRelease(prop, CORE_COMPONENT);
 	objRelease(ruleset, CORE_COMPONENT);
 
-#	if defined(HAVE_INOTIFY_INIT) || (defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE))
-	int i;
-	/* we use these vars only in inotify mode */
-	if(dirs != NULL) {
-		/* Free dirNames */
-		for(i = 0 ; i < currMaxDirs ; ++i) {
-			free(dirs[i].dirName);
-			free(dirs[i].dirNameBfWildCard);
-#			if defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)
-				free(dirs[i].pfinf->fobj.fo_name);
-				free(dirs[i].pfinf);
-#			endif
-		}
-		free(dirs->active.listeners);
-		free(dirs->configured.listeners);
-		free(dirs);
-	}
-#	endif /* #if defined(HAVE_INOTIFY_INIT) || (defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)) --- */
-
-#ifdef HAVE_INOTIFY_INIT
+	#ifdef HAVE_INOTIFY_INIT
 	free(wdmap);
-#endif
+	#endif
 ENDmodExit
 
 
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 75ed68c1e..2283066ac 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -761,6 +761,7 @@ TESTS += \
 	imfile-error-not-repeated.sh \
 	imfile-truncate.sh \
 	imfile-readmode2.sh \
+	imfile-readmode2-polling.sh \
 	imfile-readmode2-with-persists-data-during-stop.sh \
 	imfile-readmode2-with-persists.sh \
 	imfile-endregex.sh \
@@ -776,17 +777,15 @@ TESTS += \
 	imfile-wildcards.sh \
 	imfile-wildcards-dirs.sh \
 	imfile-wildcards-dirs2.sh \
+	imfile-wildcards-dirs-multi.sh \
+	imfile-wildcards-dirs-multi2.sh \
+	imfile-wildcards-dirs-multi3.sh \
+	imfile-wildcards-dirs-multi4.sh \
+	imfile-wildcards-dirs-multi5.sh \
+	imfile-wildcards-dirs-multi5-polling.sh \
+	imfile-rename-while-stopped.sh \
 	imfile-rename.sh
 
-# TEMPORARILY disable some imfile tests because refactoring
-# is needed to get them to work 100% all the time.
-# alorbach, 2018-01-05
-#	imfile-wildcards-dirs-multi.sh \
-#	imfile-wildcards-dirs-multi2.sh \
-#	imfile-wildcards-dirs-multi3.sh \
-#	imfile-wildcards-dirs-multi4.sh \
-#
-
 if HAVE_VALGRIND
 TESTS += \
 	imfile-basic-vg.sh \
@@ -1440,6 +1439,7 @@ EXTRA_DIST= \
 	random.sh \
 	testsuites/random.conf \
 	imfile-readmode2.sh \
+	imfile-readmode2-polling.sh \
 	imfile-readmode2-vg.sh \
 	imfile-readmode2-with-persists-data-during-stop.sh \
 	imfile-readmode2-with-persists.sh \
@@ -1475,8 +1475,10 @@ EXTRA_DIST= \
 	imfile-wildcards-dirs-multi2.sh \
 	imfile-wildcards-dirs-multi3.sh \
 	imfile-wildcards-dirs-multi4.sh \
+	imfile-wildcards-dirs-multi5.sh \
+	imfile-wildcards-dirs-multi5-polling.sh \
+	imfile-rename-while-stopped.sh \
 	imfile-rename.sh \
-	testsuites/imfile-wildcards.conf \
 	testsuites/imfile-wildcards-simple.conf \
 	testsuites/imfile-wildcards-dirs.conf \
 	testsuites/imfile-wildcards-dirs-multi.conf \
diff --git a/tests/diag.sh b/tests/diag.sh
index 616acdafe..1e91a4ee6 100755
--- a/tests/diag.sh
+++ b/tests/diag.sh
@@ -578,6 +578,36 @@ case $1 in
 		    . $srcdir/diag.sh error-exit 1
 		fi
 		;;
+   'wait-file-lines') 
+		# $2 filename, $3 expected nbr of lines, $4 nbr of tries
+		if [ "$4" == "" ]; then
+			timeoutend=1
+		else
+			timeoutend=$4
+		fi
+		timecounter=0
+
+		while [  $timecounter -lt $timeoutend ]; do
+			let timecounter=timecounter+1
+
+			count=$(wc -l < rsyslog.out.log)
+			if [ $count -eq $3 ]; then
+				echo wait-file-lines success, have $3 lines
+				break
+			else
+				if [ "x$timecounter" == "x$timeoutend" ]; then
+					echo wait-file-lines failed, expected $3 got $count
+					. $srcdir/diag.sh shutdown-when-empty
+					. $srcdir/diag.sh wait-shutdown
+					. $srcdir/diag.sh error-exit 1
+				else
+					echo wait-file-lines not yet there, currently $count lines
+					./msleep 200
+				fi
+			fi
+		done
+		unset count
+		;;
    'content-check-with-count') 
 		# content check variables for Timeout
 		if [ "x$4" == "x" ]; then
@@ -588,12 +618,11 @@ case $1 in
 		timecounter=0
 
 		while [  $timecounter -lt $timeoutend ]; do
-#			echo content-check-with-count loop $timecounter
 			let timecounter=timecounter+1
 
 			count=$(cat rsyslog.out.log | grep -F "$2" | wc -l)
 
-			if [ "x$count" == "x$3" ]; then
+			if [ $count -eq $3 ]; then
 				echo content-check-with-count success, \"$2\" occured $3 times
 				break
 			else
@@ -601,12 +630,12 @@ case $1 in
 					. $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd
 					. $srcdir/diag.sh wait-shutdown	# Shutdown rsyslog instance on error 
 
-					echo content-check-with-count failed, expected \"$2\" to occure $3 times, but found it $count times
+					echo content-check-with-count failed, expected \"$2\" to occur $3 times, but found it $count times
 					echo file rsyslog.out.log content is:
-					cat rsyslog.out.log
+					sort < rsyslog.out.log
 					. $srcdir/diag.sh error-exit 1
 				else
-					echo content-check-with-count failed, trying again ...
+					echo content-check-with-count have $count, wait for $3 times $2...
 					./msleep 1000
 				fi
 			fi
diff --git a/tests/imfile-discard-truncated-line.sh b/tests/imfile-discard-truncated-line.sh
index 31ba1a29e..cf2cf3abe 100755
--- a/tests/imfile-discard-truncated-line.sh
+++ b/tests/imfile-discard-truncated-line.sh
@@ -54,7 +54,7 @@ printf 'HEADER msgnum:0
 HEADER msgnum:1
 HEADER msgnum:2 aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa\\\\n msgnum:3 bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb\\\\n msgnum:4 ccccccc
 HEADER msgnum:6 eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee\\\\n msgnum:7 ffffffffffffffffffffffffffffffffffffffffffff\\\\n msgnum:8 ggggggg
-HEADER msgnum:9\n' | cmp -b rsyslog.out.log
+HEADER msgnum:9\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid multiline message generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/imfile-endregex-save-lf-persist.sh b/tests/imfile-endregex-save-lf-persist.sh
index 808e98d8e..260aeb5cd 100755
--- a/tests/imfile-endregex-save-lf-persist.sh
+++ b/tests/imfile-endregex-save-lf-persist.sh
@@ -47,7 +47,7 @@ echo 'END OF TEST' >> rsyslog.input
 
 printf 'HEADER msgnum:0\\\\n msgnum:1\\\\n msgnum:2
 HEADER msgnum:3
-HEADER msgnum:4\\\\n msgnum:5\n' | cmp -b rsyslog.out.log
+HEADER msgnum:4\\\\n msgnum:5\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid multiline message generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/imfile-endregex-save-lf.sh b/tests/imfile-endregex-save-lf.sh
index 67a51c66f..5ba03250a 100755
--- a/tests/imfile-endregex-save-lf.sh
+++ b/tests/imfile-endregex-save-lf.sh
@@ -41,7 +41,7 @@ echo 'END OF TEST' >> rsyslog.input
 . $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
 . $srcdir/diag.sh wait-shutdown    # we need to wait until rsyslogd is finished!
 
-printf 'HEADER msgnum:0\\\\n msgnum:1\\\\n msgnum:2\n' | cmp -b rsyslog.out.log
+printf 'HEADER msgnum:0\\\\n msgnum:1\\\\n msgnum:2\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid multiline message generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/imfile-endregex-timeout-none.sh b/tests/imfile-endregex-timeout-none.sh
index 6d5b2683a..a639c9a59 100755
--- a/tests/imfile-endregex-timeout-none.sh
+++ b/tests/imfile-endregex-timeout-none.sh
@@ -2,7 +2,7 @@
 # This is part of the rsyslog testbench, licensed under ASL 2.0
 echo ======================================================================
 echo [imfile-endregex-timeout-none.sh]
-. $srcdir/diag.sh check-inotify-only
+. $srcdir/diag.sh check-inotify
 . $srcdir/diag.sh init
 . $srcdir/diag.sh generate-conf
 . $srcdir/diag.sh add-conf '
@@ -42,7 +42,7 @@ echo 'END OF TEST' >> rsyslog.input
 . $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
 . $srcdir/diag.sh wait-shutdown    # we need to wait until rsyslogd is finished!
 
-printf 'HEADER msgnum:0\\\\n msgnum:1\\\\n msgnum:2\\\\n msgnum:3\n' | cmp -b rsyslog.out.log
+printf 'HEADER msgnum:0\\\\n msgnum:1\\\\n msgnum:2\\\\n msgnum:3\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid multiline message generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/imfile-endregex-timeout-with-shutdown.sh b/tests/imfile-endregex-timeout-with-shutdown.sh
index 5644b6bf7..bd9221c69 100755
--- a/tests/imfile-endregex-timeout-with-shutdown.sh
+++ b/tests/imfile-endregex-timeout-with-shutdown.sh
@@ -61,7 +61,7 @@ echo ' msgnum:5
 
 printf 'HEADER msgnum:0\\\\n msgnum:1
 HEADER  msgnum:2\\\\n msgnum:3\\\\n msgnum:4
-HEADER  msgnum:5\\\\n msgnum:6\n' | cmp -b rsyslog.out.log
+HEADER  msgnum:5\\\\n msgnum:6\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid multiline message generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/imfile-endregex-timeout.sh b/tests/imfile-endregex-timeout.sh
index 13786bed7..249895692 100755
--- a/tests/imfile-endregex-timeout.sh
+++ b/tests/imfile-endregex-timeout.sh
@@ -46,7 +46,7 @@ echo 'END OF TEST' >> rsyslog.input
 . $srcdir/diag.sh wait-shutdown    # we need to wait until rsyslogd is finished!
 
 printf 'HEADER msgnum:0\\\\n msgnum:1
-HEADER  msgnum:2\\\\n msgnum:3\n' | cmp -b rsyslog.out.log
+HEADER  msgnum:2\\\\n msgnum:3\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid multiline message generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/imfile-file-not-found-error.sh b/tests/imfile-file-not-found-error.sh
index eab0e7cea..268e34fa4 100755
--- a/tests/imfile-file-not-found-error.sh
+++ b/tests/imfile-file-not-found-error.sh
@@ -1,7 +1,7 @@
 #!/bin/bash
 # add 2017-04-28 by Pascal Withopf, released under ASL 2.0
 echo [imfile-file-not-found-error.sh]
-. $srcdir/diag.sh check-inotify-only
+. $srcdir/diag.sh check-inotify
 . $srcdir/diag.sh init
 . $srcdir/diag.sh generate-conf
 . $srcdir/diag.sh add-conf '
@@ -35,7 +35,7 @@ fi
 
 printf 'testmessage1
 testmessage2
-testmessage3\n' | cmp -b rsyslog.out.log
+testmessage3\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid response generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/imfile-readmode2-with-persists.sh b/tests/imfile-readmode2-with-persists.sh
index 9db15b559..c8083201c 100755
--- a/tests/imfile-readmode2-with-persists.sh
+++ b/tests/imfile-readmode2-with-persists.sh
@@ -20,6 +20,10 @@ sleep 1
 echo stopping rsyslog
 . $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
 . $srcdir/diag.sh wait-shutdown    # we need to wait until rsyslogd is finished!
+
+echo spool:
+ls -l test-spool
+
 echo restarting rsyslog
 . $srcdir/diag.sh startup imfile-readmode2-with-persists.conf
 echo restarted rsyslog, continuing with test
